/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/IntegerResponse.h>
#include <activemq/exceptions/NullPointerException.h>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshaling code for OpenWire format for IntegerResponse
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
IntegerResponse::IntegerResponse()
{
    this->result = 0;
}

////////////////////////////////////////////////////////////////////////////////
IntegerResponse::~IntegerResponse()
{
}

////////////////////////////////////////////////////////////////////////////////
DataStructure* IntegerResponse::cloneDataStructure() const {
    IntegerResponse* integerResponse = new IntegerResponse();

    // Copy the data from the base class or classes
    integerResponse->copyDataStructure( this );

    return integerResponse;
}

////////////////////////////////////////////////////////////////////////////////
void IntegerResponse::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    Response::copyDataStructure( src );

    const IntegerResponse* srcPtr = dynamic_cast<const IntegerResponse*>( src );

    if( srcPtr == NULL || src == NULL ) {
    
        throw exceptions::NullPointerException(
            __FILE__, __LINE__,
            "IntegerResponse::copyDataStructure - src is NULL or invalid" );
    }
    this->setResult( srcPtr->getResult() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char IntegerResponse::getDataStructureType() const {
    return IntegerResponse::ID_INTEGERRESPONSE; 
}

////////////////////////////////////////////////////////////////////////////////
std::string IntegerResponse::toString() const {

    ostringstream stream;

    stream << "Begin Class = IntegerResponse" << std::endl;
    stream << " Value of IntegerResponse::ID_INTEGERRESPONSE = 34" << std::endl; 
    stream << " Value of Result = " << this->getResult() << std::endl;
    stream << Response::toString();
    stream << "End Class = IntegerResponse" << std::endl;

    return stream.str();
}

////////////////////////////////////////////////////////////////////////////////
bool IntegerResponse::equals( const DataStructure* value ) const {
    const IntegerResponse* valuePtr = dynamic_cast<const IntegerResponse*>( value );

    if( valuePtr == NULL || value == NULL ) {
        return false;
    }
    if( this->getResult() != valuePtr->getResult() ) {
        return false;
    }
    if( !Response::equals( value ) ) {
        return false;
    }
    return true;
}

////////////////////////////////////////////////////////////////////////////////
int IntegerResponse::getResult() const {
    return result;
}

////////////////////////////////////////////////////////////////////////////////
void IntegerResponse::setResult(int result ) {
    this->result = result;
}

